#include "Parsodus/lrtables/LR0Itemset.h"

namespace pds {
namespace lr {

LR0Itemset::LR0Itemset() : LR0ItemsetBase<LR0Itemset>()
{}

LR0Itemset::LR0Itemset(std::shared_ptr<Rule> start) : LR0ItemsetBase<LR0Itemset>(start)
{}

bool LR0Itemset::needsFollow() {
    return false;
}


std::set<std::size_t> LR0Itemset::getReduces(const Grammar& g, std::string) const {
    std::set<std::size_t> res;
    for (auto& item : m_items) {
        if (item.dotIdx >= item.rule->tail.size()) {
            res.insert(std::find(g.rules.begin(), g.rules.end(), item.rule) - g.rules.begin());
        }
    }
    return res;
}

} /* lr  */ 
} /* pds  */ 
